#include <time.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/dir.h>

#include "clean_mail.h"

extern char log_file[256];
extern char imp_file[256];
extern char exl_file[256];
extern char date[21];
extern time_t t;

// file kompletter Pfad fuer list.bcm des betreffenden Users
// mycall eigenes Box-Call

void find_mail(char *file, char *mycall)
{
  struct list_bcm
  {
    char file[7];		// Filename der MSG
    char flag1;
    char send[6];		// Absendercall
    char flag2;			// E erase / F forward
    char receive[6];		// Empfaengercall
    char flag3;
    char read;			// R wenn gelesen
    char flag4;
    char receive_bbs[6];	// Box von der Mail kam
    char at;			// '@'
    char fwdbbs[6];		// MYBBS von Empfaenger
    char mid[13];
    char life[4];		// Lifetime
    char empty1[8];		
    char flag5;			// N, R, B, L, S
    char empty[15];		// ??
    char subject[50];		// Titel der Mail	
  };

  time_t t_m;			// Uhrzeit der Mail
  
  FILE 	*fp;			// Filepointer
  char	*ptr;			// Zeiger auf String

  char dummy[0xff];		// 255 Byte reservieren
  
  FILE *fp_imp;			// Filepointer Import-Datei
  char output[82];		// Ausgabezeile
  
  FILE  *fp_log;                // Filepointer Log-Datei  

  FILE  *fp_exl;                // Filepointer Ausnahmen
    
  int n;			// Mail-Counter
  int m;			// Zaehler
  int limit;			// Anzahl der Tage, die ein Mail
				// ungelesen liegenblieben darf

  char buf[MAXLEN+1];		// Buffer
  char fwdbbs[11];		// MYBBS Empfaenger
  char send_call[11];		// Absender der Mail
  char user_call[11];		// Empfaenger der Mail
  char subject[50];		// Titel der Mail
	
  struct list_bcm *recp;		
  recp = (struct list_bcm*) dummy;

  // $bcm/user/calll/list.bcm
  if( (fp = fopen(file,"r")) == NULL)
    return;
  
  // Import-File
  if( (fp_imp = fopen(imp_file,"a")) == NULL)
    return;
  
  // Log-File
  if( (fp_log = fopen(log_file,"a")) == NULL)
    return;
  
  n = 1;
  
  while( fread(dummy, sizeof (struct list_bcm),1,fp) )
  {
    strcpy(fwdbbs,"      ");	
    strncpy(fwdbbs,recp->fwdbbs,6);
    extract(fwdbbs);

    strcpy(send_call,"      ");	
    strncpy(send_call,recp->send,6);
    extract(send_call);

    strcpy(user_call,"      ");
    strncpy(user_call,recp->receive,6);
    extract(user_call);

    strcpy(subject,"                                                 ");	
    strncpy(subject,recp->subject,40);

    if ( (recp->flag2 != 'E') && ( recp->flag2 != 'F') )
    {			
      // Mails die geforwardet werden
      if( strstr(mycall,fwdbbs) == NULL )
      {
        if ( (recp->flag5 == 'N') )	// NO
        {
          fprintf(fp_imp,"forward -h %s %i @%-6s \n",user_call,n,fwdbbs);
        }
        else
        if ( (recp->flag5 == 'R') )	// REJECTED
        {
          fprintf(fp_imp,"e %s %i \n\n",user_call,n);
          fprintf(fp_log,"%s #R Erase Mail %-6s > %-6s \n",date,send_call, user_call);
        }
        else
        if ( (recp->flag5 == 'B') )	// No Auto-BIN 
        {
          fprintf(fp_imp,"e %s %i \n\n",user_call,n);
          fprintf(fp_log,"%s #B Erase Mail %-6s > %-6s \n",date,send_call, user_call);
        }
        else
        if ( (recp->flag5 == 'S') )	// Size 
        {
          fprintf(fp_imp,"e %s %i \n\n",user_call,n);
          fprintf(fp_log,"%s #B Erase Mail %-6s > %-6s \n",date,send_call, user_call);
        }
        else
        if ( (recp->flag5 == 'L') )	// FWD-Loop 
        {
          fprintf(fp_imp,"send %s Your mail to %s \n\n",send_call, user_call);
          fprintf(fp_imp,"Your mail to %s could not be forwarded: \n\n",user_call); 
          fprintf(fp_imp,"Reason: Forward-Loop \n\n");
          fprintf(fp_imp,"Message generated by %s %s\n",TITLE,VER);
          fprintf(fp_imp,"NNNN\n\n");
          fprintf(fp_imp,"e %s %i \n\n",user_call,n);
          fprintf(fp_log,"%s #B Erase Mail %-6s > %-6s \n",date,send_call,user_call);
        }
      } 

      // Unzustellbare Mails
      if ( strlen(fwdbbs) == 0)
      {
        fprintf(fp_imp,"send %s Your mail to %s \n\n",send_call, user_call);
        fprintf(fp_imp,"Your mail to %s could not be forwarded: \n\n",user_call); 
        fprintf(fp_imp,"Reason: unknown MYBBS \n\n");
        fprintf(fp_imp,"Message generated by %s %s\n",TITLE,VER);
        fprintf(fp_imp,"NNNN\n\n");
        fprintf(fp_imp,"e %s %i \n\n",user_call,n);
        fprintf(fp_log,"%s #U Erase Mail %-6s > %-6s \n",date,send_call,user_call);
      }

      if ( recp->read != 'R' )
      {
      
        limit = LIMIT_DAY;
        
        if( (fp_exl = fopen(exl_file,"r")) != NULL)
        {
          while ( (fgets(buf,MAXLEN,fp_exl )) != NULL)
          {
            extract(buf);
            if (strcasecmp(buf,send_call) == 0)
              limit = 9999;

            if (strcasecmp(buf,user_call) == 0)
              limit = 9999;
          }
          fclose(fp_exl);
        }

        strncpy(buf,recp->file,7);
        buf[7]=0x00;
        t_m = filename2time(buf);

        if ( ( (t-t_m)/3600/24) > limit)
        {
          fprintf(fp_imp,"send %s Your Mail to %s \n\n",send_call,user_call);
          fprintf(fp_imp,"Subject: %40s \n\n",subject);
          fprintf(fp_imp,"is unread since %u days.\n\n",limit);  
          fprintf(fp_imp,"Message generated by %s %s\n\n",TITLE,VER);
          fprintf(fp_imp,"NNNN\n\n");
          fprintf(fp_imp,"e %s %i \n\n",user_call,n);
          fprintf(fp_log,"%s #X Erase Mail %-6s > %-6s \n",date,send_call,user_call);
        }
      }
    }
    n ++;

    for(m = 0;m > 0xa0;m ++)
    {
      dummy[m] = 0x00;
    }
  }

  fclose(fp);
  fclose(fp_imp);
  fclose(fp_log);
}		
