#include <time.h>
#include <errno.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/dir.h>

#include "clean_mail.h"

char log_file[256];		// Log-File global
char imp_file[256];		// Import-File global
char exl_file[256];		// Import-File global

time_t t;			// Aktuelle Systemzeit in UNIX Format

char date[21];			// Datum/Uhrzeit global 

int main(int argc,char *argv[])
{
  char	*ptr;			// Zeiger aus String

  DIR *dp;			// Directory
  struct direct *dir;

  FILE 	*fp_log;		// Filepointer

  char file[256];		// Filename
  char mycall[30];		// Boxrufzeichen		
  char config_file[256];	// Configuration-File 
  char bcm_user[256];		// Pfad fuer User-Files bcm
  int err_no;			// Wert fuer Fehler 		
 		
  t = time(NULL);

  strftime(date,20,"%d.%m.%Y %H:%M:%S",gmtime(&t));
	
  // File-Name fuer init.bcm erzeugen
  sprintf(config_file,"%s/init.bcm",getenv("HOME"));

  // File-Name fuer Log-File
  sprintf(log_file,"%s/trace/%s",getenv("HOME"),CLEAN_MAIL_LOG);

  // File-Name fuer Import-File
  sprintf(imp_file,"%s/%s",getenv("HOME"),CLEAN_MAIL_IMP);

  // File-Name fuer Exclude-File
  sprintf(exl_file,"%s/%s",getenv("HOME"),EXLUDE_CALL);

  // sprintf(config_file,"/bcm/init.bcm");
  // sprintf(log_file,"/bcm/trace/%s",CLEAN_MAIL_LOG);
  // sprintf(imp_file,"/bcm/%s",CLEAN_MAIL_IMP);
  // sprintf(exl_file,"/bcm/%s",EXLUDE_CALL);


  // altes Import-File loeschen
  unlink(imp_file);
    
  if( (errno != 2) && (errno != 0) )
  {
    fp_log = fopen(file,"a");
    fprintf(fp_log,"%s Couldn't remove %s \n",date,CLEAN_MAIL_IMP);
    fclose(fp_log);
    return (-1);
  }

  // Aus init.bcm userpath ermitteln
  get_para(file,config_file,"userpath");

  if (strlen(file) == 0x00)
  exit -1;

  // Pfad fuer User-File
  sprintf(bcm_user,"%s/%s",getenv("HOME"),file);

  // sprintf(bcm_user,"/bcm/%s",file);

  // Aus init.bcm mycall ermitteln
  get_para(mycall,config_file,"boxaddress");

  if (strlen(mycall) == 0x00)
  {
    fprintf(stderr,"Boxcall unknown \n\r");
    return (-1);
  }
 
  // Unterverzeichnisse unter <userpath> suchen
  if ((dp = opendir(bcm_user)) == NULL)
  {
    fprintf(stderr,"Cannot open directory \n");
    return (-1);	
  }
	
  // alle Unterverzeichnisse werden nach User-Mail durchsucht
  while (( dir = readdir(dp)) != NULL)
  {
    if (dir->d_ino == 0)
      continue;
	
    // Dateiname erzeugen <userpath>/<user>/<list.bcm>	
    sprintf(file,"%s/%s/list.bcm",bcm_user,dir->d_name);

    // User-Liste durchsuchen
    find_mail(file,mycall);

  }		
  closedir(dp);

  exit(0);
}
