#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <netdb.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <errno.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <termios.h>

#define VNUMMER "1.04"
#define PROGNAME "lconnect"

void endmessage(char *string, ...);
int holsock(void);
void main(void);
void init_sock(void);

int sock;        /* connected socket descriptor */
struct hostent *hp;   /* pointer to host info for remote host */
struct servent *sp;   /* pointer to service information */
long timevar;     /* contains time returned by time() */
char *ctime();      /* declare time formatting routine */
struct sockaddr_in myaddr_in; /* for local socket address */
struct sockaddr_in peeraddr_in; /* for peer socket address */
int si;
int so;

void init_sock(char *host)
{
  unsigned int addrlen;

  memset ((char *)&myaddr_in, 0, sizeof(struct sockaddr_in));
  memset ((char *)&peeraddr_in, 0, sizeof(struct sockaddr_in));

  peeraddr_in.sin_family = AF_INET;
  hp = gethostbyname (host);
  if (hp == NULL) 
    endmessage("invalid host %s ",host);
  peeraddr_in.sin_addr.s_addr = ((struct in_addr *)(hp->h_addr))->s_addr;
  sp = getservbyname ("bcmradio", "tcp");
  if (sp == NULL) 
    peeraddr_in.sin_port = htons(8124); 
  else  
    peeraddr_in.sin_port = sp->s_port;


  sock = socket (AF_INET, SOCK_STREAM, 0);
  if (sock == -1) 
    endmessage("socket: %s",strerror(errno));
  if (connect(sock,(struct sockaddr *) &peeraddr_in, 
      sizeof(struct sockaddr_in)) == -1) 
    endmessage(PROGNAME": %s",strerror(errno));
  
  addrlen = sizeof(struct sockaddr_in);
  if (getsockname(sock,(struct sockaddr *) &myaddr_in, &addrlen) == -1) 
    endmessage("getsockname: %s",strerror(errno));
}

char endstr[200]="";

void endmessage( char *string, ...)
{ va_list argpoint;

  va_start(argpoint,string);
  vsprintf(endstr,string,argpoint);
  va_end(argpoint);

  exit(0);
}

void te_end(void)
{
  if(endstr[0])
    printf("ERROR: %s\n", endstr);
}

main(int argc,char *argv[])
{ char buffer[513]="";
  int n;
  int i;

  atexit(te_end);
  
  if (argc != 4) 
    endmessage("Usage:  %s host tocall mycall\n", argv[0]);
  else  
    init_sock(argv[1]);

  struct termios tio;
 memset(&tio,0,sizeof(tio));
    //control mode flags, eg. speed of serial line
    tio.c_cflag=B19200|CRTSCTS|CS8|CLOCAL|CREAD;
    //input mode flags
    tio.c_iflag=IGNPAR;
    //output mode flags
    tio.c_oflag=0;
    //local mode flags (no echo, non canonical..)
    tio.c_lflag=0;
  tcsetattr(STDIN_FILENO,TCSANOW,&tio); 



  fd_set read_fd;

  sprintf(buffer,"connect ax25");
  for (i=2;i<argc;i++)
    sprintf(buffer+strlen(buffer)," %s",argv[i]);
  sprintf(buffer+strlen(buffer),"\r");  
 
  //printf("befehl: %s\n\n\n",buffer); //DEBUG
  write(sock,buffer,strlen(buffer));

  while(1)
  {
    FD_ZERO(&read_fd);
    FD_SET(STDIN_FILENO, &read_fd);
    FD_SET(sock,&read_fd);
    select(sock+1,&read_fd,NULL,NULL,NULL);
    if (FD_ISSET(sock,&read_fd))
    { if ((n=read(sock,buffer,512)) <= 0)
        endmessage(0); //normal end
       write(STDOUT_FILENO,buffer,n);
    }
    if (FD_ISSET(STDIN_FILENO,&read_fd))
    { if ((n=read(STDIN_FILENO,buffer,512)) == -1)
      { close(sock); 
        break;
      }
      buffer[n]=0;
      for (i=0;buffer[i];i++)
        if (buffer[i]==10) //this makes it not transparent!!
          buffer[i]=13; 
       write(sock,buffer,n);
      if (errno!=2)
        endmessage(0);    
    }
  }
}
