/***************************************************************

  BayCom(R)        Packet-Radio fuer IBM PC

  OpenBayCom-Mailbox

  ------------------------------------------
  Definitionen und Deklarationen fuer Mailbox
  ------------------------------------------


  Copyright (C)       Florian Radlherr
                      Taubenbergstr. 32
                      83627 Warngau

  Alle Rechte vorbehalten / All Rights Reserved

 ***************************************************************/

#ifndef _UTIL_H
#define _UTIL_H

#define ltell(fh) lseek(fh,0L,SEEK_CUR)
#define leof(fh) (lseek(fh,0L,SEEK_CUR)==filelength(fh))

// Bits fuer die Optionen

#define o_a (0x00000001L)
#define o_b (0x00000002L)
#define o_c (0x00000004L)
#define o_d (0x00000008L)
#define o_e (0x00000010L)
#define o_f (0x00000020L)
#define o_g (0x00000040L)
#define o_h (0x00000080L)
#define o_i (0x00000100L)
#define o_j (0x00000200L)
#define o_k (0x00000400L)
#define o_l (0x00000800L)
#define o_m (0x00001000L)
#define o_n (0x00002000L)
#define o_o (0x00004000L)
#define o_p (0x00008000L)
#define o_q (0x00010000L)
#define o_r (0x00020000L)
#define o_s (0x00040000L)
#define o_t (0x00080000L)
#define o_u (0x00100000L)
#define o_v (0x00200000L)
#define o_w (0x00400000L)
#define o_x (0x00800000L)
#define o_y (0x01000000L)
#define o_z (0x02000000L)
//oe3dzw Neue Flags
#define o_0  (0x04000000L)
#define o_b1 (0x04000000L)
#define o_1  (0x08000000L)
#define o_d1 (0x08000000L)
#define o_2  (0x20000000L)
#define o_3  (0x40000000L)
#define o_4  (0x80000000L)

typedef enum
{ j_idle,
  j_fwdlink,
  j_fwdsend,
  j_fwdsendf,
  j_fwdrecv,
  j_fwdrecvf,
  j_fbb_send_propose,
  j_fbb_send_mail,
  j_fbb_send_delay,
  j_fbb_recv_propose,
  j_fbb_recv_mail,
  j_fbb_end,
  j_fbb_error,
  j_send,
  j_read,
  j_cmd,
  j_search,
  j_purge,
  j_reorg,
  j_tell,
  j_node,
  j_ftrans,
  j_router,
  j_convers
} job_typ;

typedef int handle;

//****************************
//       mbsema.c
//****************************
#define fopen error
#define fclose error
void    sema_list (void);
void    openfile_list (void);
FILE    *s_fopen (char *fname, char *mode);
handle  s_open (char *fname, char *mode);
int     s_set (handle fh, char *fname, char *mode);
void    s_fsetopt (FILE *f, char opt);
void    s_setopt (handle fh, char opt);
void    s_fclose (FILE *f);
void    s_close (handle fh);
void    close_task (int tid);
void    sema_init (void);
int     sema_send (void);
int     sema_access (char *name);
int     sema_test (char *name);
int     sema_lock (char *name);
void    sema_unlock (char *name);

//****************************
//       bc_util.cpp
//****************************
typedef enum delta_t
{ zs_runtime,
  zs_seconds,
  zs_cputime,
  zs_cpuexact
} delta_t;

unsigned strcrc (char *s);
char    *stristr (char *s1, char *s2);
int     strpos (char *s1, char *s2);
char    *nexttoken (char *buf, char *token, int maxlen);
char    *nextword (char *buf, char *token, int maxlen);
int     parseline (char *s, char *indizes);
char    *get_searchitem (char *instr, char *str, int maxlen);
char    *datestr (time_t utime, int ymode);
int     newdate (time_t d1, time_t d2);
char    *zeitspanne (time_t zeit, delta_t mode);
time_t  parse_time (char *datum);
int     filecopy (char *src, char *dest);
int     xunlink (char *name);
int     xrename (char *src, char *dest);
long    filesize (char *name);
void    rmcrlf (char *line);
int     isdir (char *name);
time_t  filetime (char *name);
time_t  file_isreg (char *name);
char    *defext (char *name, char *ext);
void    killbackslash (char *s);
void    remove_emptyadd (char *s);
char    jokcmp (char *string, char *jokex, char negotiation);
int     setfiletime (char *filename, unsigned long binfiletime); //dk2ui
unsigned long getdostime (time_t utime); //dk2ui
//void  filepath(char *name,char *filename);
//FILE  *sysopen(char *name,char *mode);
//char  *syspath(char *name);

//****************************
//       mbcmd.c
//****************************
void    subst    (char *s, char i, char j);
void    subst1   (char *s, char i, char j);
char    *skip    (char *s);
int     blkill   (char *s);
void    cut_all  (char *s); //dk2ui
void    cutblank (char *s); //dk2ui
int     nextdez  (char **bf);
int     readcmd  (char *beftab[], char **buffer, unsigned int minimum);

extern char globalpath[];       //ad_util.cpp

#endif
